org.restlet.representation

## Class WriterRepresentation

- java.lang.Object
- - org.restlet.representation.Variant
  - - org.restlet.representation.RepresentationInfo
    - - org.restlet.representation.Representation
      - - org.restlet.representation.CharacterRepresentation
        - - org.restlet.representation.WriterRepresentation

Direct Known Subclasses:
  JacksonRepresentation

    public abstract class WriterRepresentation
    extends CharacterRepresentation

Representation based on a BIO characters writer. This class is a good basis to write your own representations, especially for the dynamic and large ones.
For this you just need to create a subclass and override the abstract Representation.write(Writer) method. This method will later be called back by the connectors when the actual representation's content is needed.

Author:
  Jerome Louvel

### Field Summary

### Fields inherited from class org.restlet.representation.Representation

`UNKNOWN_SIZE`

### Constructor Summary

Constructors
Constructor and Description
`WriterRepresentation(MediaType mediaType)` Constructor.
`WriterRepresentation(MediaType mediaType, long expectedSize)` Constructor.

### Method Summary

Methods
`java.io.Reader` `getReader()` Returns a characters reader with the representation's content.
`void` `release()` Calls parent's implementation.
`void` `write(java.io.OutputStream outputStream)` Writes the representation to a byte stream.

### Methods inherited from class org.restlet.representation.CharacterRepresentation

`getChannel, getStream, write`

### Methods inherited from class org.restlet.representation.Representation

`checkDigest, checkDigest, computeDigest, createEmpty, exhaust, getAvailableSize, getDigest, getDisposition, getDownloadName, getExpirationDate, getRange, getSize, getText, isAvailable, isDownloadable, isTransient, setAvailable, setDigest, setDisposition, setDownloadable, setDownloadName, setExpirationDate, setRange, setSize, setTransient, write`

### Methods inherited from class org.restlet.representation.RepresentationInfo

`getModificationDate, getTag, setModificationDate, setTag`

### Methods inherited from class org.restlet.representation.Variant

`createClientInfo, equals, getCharacterSet, getEncodings, getIdentifier, getLanguages, getLocationRef, getMediaType, includes, isCompatible, setCharacterSet, setEncodings, setIdentifier, setIdentifier, setLanguages, setLocationRef, setLocationRef, setMediaType, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### WriterRepresentation

    public WriterRepresentation(MediaType mediaType)

Constructor.

Parameters:
  `mediaType` - The representation's mediaType.

#### WriterRepresentation

    public WriterRepresentation(MediaType mediaType,
                        long expectedSize)

Constructor.

Parameters:
  `mediaType` - The representation's mediaType.
  `expectedSize` - The expected writer size in bytes.

### Method Detail

#### getReader

    public java.io.Reader getReader()
                             throws java.io.IOException

Description copied from class: `Representation`
Returns a characters reader with the representation's content. This method is ensured to return a fresh reader for each invocation unless it is a transient representation, in which case null is returned. If the representation has no character set defined, the system's default one will be used.

Specified by:
  `getReader` in class `Representation`
Returns:
  A reader with the representation's content.
Throws:
  `java.io.IOException`

#### release

    public void release()

Calls parent's implementation.

Overrides:
  `release` in class `Representation`

#### write

    public void write(java.io.OutputStream outputStream)
               throws java.io.IOException

Description copied from class: `Representation`
Writes the representation to a byte stream. This method is ensured to write the full content for each invocation unless it is a transient representation, in which case an exception is thrown.
Note that the class implementing this method shouldn't flush or close the given `OutputStream` after writing to it as this will be handled by the Restlet connectors automatically.

Overrides:
  `write` in class `CharacterRepresentation`
Parameters:
  `outputStream` - The output stream.
Throws:
  `java.io.IOException`